#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    double *X, *I; 
    int DIM, max_NOT_MIN, X_rows, X_cols;
    mxArray *XData;

    XData = prhs[0];

    X = mxGetPr(XData);
    X_rows = mxGetM(XData);
    X_cols = mxGetN(XData);
    DIM = mxGetScalar(prhs[1]);
    max_NOT_MIN = mxGetScalar(prhs[2]);

    if (DIM==1){ 
        plhs[0] = mxCreateDoubleMatrix(1, X_cols, mxREAL); 
    }else{
        if(DIM==2){
            plhs[0] = mxCreateDoubleMatrix(X_rows, 1, mxREAL);
        }else{
            mexPrintf("\nError: argmax for 3D-array is still unsupported.\n");
            return;
        }
    }
    I = mxGetPr(plhs[0]);

    if (max_NOT_MIN == 0)   
        arg_min(X,X_rows,X_cols,I,DIM);
    else
        arg_max(X,X_rows,X_cols,I,DIM);
 }
 void arg_max(double *X, int X_rows, int X_cols, double *I, int DIM, int max_NOT_MIN){
    int r, c, pmax;
    double vmax;

    if (DIM==1){
        for (c=0; c<X_cols; c++){
            pmax = 1;
            vmax = X[0+c*X_rows];
            for (r=1; r<X_rows; r++){                
                if (X[r+c*X_rows] > vmax){
                    vmax = X[r+c*X_rows];
                    pmax = r+1;
                }
            }
            I[c] = pmax;
        }
    }else{
        if(DIM==2){
            for (r=0; r<X_rows; r++){
                pmax = 1;
                vmax = X[r+0*X_rows];
                for (c=1; c<X_cols; c++){
                    if (X[r+c*X_rows] > vmax){
                        vmax = X[r+c*X_rows];
                        pmax = c+1;
                    }
                }
                I[r] = pmax;
            }
        }
    }     
 }
  void arg_min(double *X, int X_rows, int X_cols, double *I, int DIM){
    int r, c, pmin;
    double vmin;

    
    if (DIM==1){
        for (c=0; c<X_cols; c++){
            pmin = 1;
            vmin = X[0+c*X_rows];
            for (r=1; r<X_rows; r++){                
                if (X[r+c*X_rows] < vmin){
                    vmin = X[r+c*X_rows];
                    pmin = r+1;
                }
            }
            I[c] = pmin;
        }
    }else{
        if(DIM==2){
            for (r=0; r<X_rows; r++){
                pmin = 1;
                vmin = X[r+0*X_rows];
                for (c=1; c<X_cols; c++){
                    if (X[r+c*X_rows] < vmin){
                        vmin = X[r+c*X_rows];
                        pmin = c+1;
                    }
                }
                I[r] = pmin;
            }
        }
    }     
 }
 

